# topic/dccstats stuff.
alias dge {
  if (!noecho) {echo $*}}

^on ^dcc_header * {
  dge $cparse("%K ÖÄÄÄÄÄÄ%nÄ%KÄÄÄÄ%nÄÄÄÄ%KÄ%nÄÄ%WÄÄ%nÄ%WÄÄ%nÄÄÄÄ%WÄÄÄÄ%nÄ%WÄÄÄÄÄÄÄÄÄÄÄÄÄÄÄ%nÄ%WÄÄÄÄ%nÄÄ%WÄ%nÄÄ%WÄÄ%nÄÄ%KÄ%nÄÄÄÄ%KÄÄÄÄ%nÄ%KÄÄÄÄ·%n")
  dge $cparse("%K º%C n%cum %Kù %ctype   %Kù %cnick         %Kù %cprogress                %Kù %ckb%C/%cs %Kù %cfile       %Kº%n")}

^on ^dcc_post * {
  dge $cparse("%K ÓÄÄÄÄÄÄ%nÄ%KÄÄÄÄ%nÄÄÄÄ%KÄ%nÄÄ%WÄÄ%nÄ%WÄÄ%nÄÄÄÄ%WÄÄÄÄ%nÄ%WÄÄÄÄÄÄÄÄÄÄÄÄÄÄÄ%nÄ%WÄÄÄÄ%nÄÄ%WÄ%nÄÄ%WÄÄ%nÄÄ%KÄ%nÄÄÄÄ%KÄÄÄÄ%nÄ%KÄÄÄÄ½%n")}

^on ^dcc_statf1 * {
  @ _dp = [$0]
  @ _de = fixeta($3 $4)
  @ _df.tr = [$numzeros(2 $3):$numzeros(2 $4)]
  ^tempset floating_point_math_var on
  dge $cparse("%K º %K#%n$[2]_df.n %Kù %n$[6]tolower($_dt) %Kù %n$[12]_dn %Kù %n$_percentbar($1 $2 10) $[-4]0%K%%%n $[-6]_df.tr %Kù %n$[4]trunc(1 $_ds) %Kù %n$numdots(10 $_df.f) %Kº%n")
  ^untset floating_point_math_var}

^on ^dcc_stat * {
  dge $cparse("%K º %K#%n$[2]0 %Kù %n$[6]tolower($1) %Kù %n$[12]2 %Kù %n$[23]tolower($3) %Kù %nn/a  %Kù %n$[10]tolower($5) %Kº%n")}

on -dcc_connect * {
  if (match($1 SEND GET RESEND REGET)) {
    ^wset * -status_user7
    @ _oldsf3 = status_format3
    ^wset * status_format3 $(cl) %7 %- 
    @ dccs++
    ^hook _dcc.stats}}
on -dcc_lost * {
  if (match($1 SEND GET RESEND REGET)) {
    @ dccs--
    unless (dccs) {
      ^wset * status_format3 $_oldsf3
      @ _oldsf3 = _dt = _dn = _df.n = _df.f = _d.asf = _ds = _dp = _ldp = _de = _df = []}}}
on ^dcc_statf * {
  @ _df.n = [$0]
  @ _df.f = [$5]
  @ _d.asf = [$*]
  @ _dt = [$1]
  @ _dn = [$2]
  @ _ds = [$4]}

on -hook _dcc.stats {
  @ noecho = 1
  ^dcc
  @ noecho = 0
  if (_dp != _ldp) {
    @ _ldp = _dp
    ^tempset floating_point_math_var on
    ^wset * status_user7 $(c.hk)[$(c.hw)$numdots(7 $tolower($_dt)) $(c.hw)$numdots(10 $_dn) $_percentbar($_dp 100 10) $(cl)$_de$(c.hk)] $(cl)
    ^untset floating_point_math_var
    if (dccs) {
      ^timer -ref 23 1 ^hook _dcc.stats}}}
#sjk'98
